<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

class plgJshoppingProductsprice_round_to_parameter extends JPlugin {
	  
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
        $this->loadLanguage();       
	}
	
	
	public function onJshopProductGetAttributesDatasAfter($obj,$vars){
		foreach($vars['data']['attributeValues'] as $ka=>$va){
			foreach($va as $kv=>$vv){
				$va[$kv]->addprice = $this->roundToParameterPrice($va[$kv]->addprice);
			}
		}
	}
	
	private function roundToParameterPrice($value){
       $addon = \JSFactory::getTable('addon');
       $addon->loadAlias('addon_price_round_to_parameter');
       $addon_config = $addon->getParams();
	   
       $prmtr = $addon_config['parameter'];
       if($prmtr < 1){

           $krok = $prmtr * 100;
           
           $value = round($value, 2);
           $value_temp = round(100*($value - floor($value)));
           
           $min_val = floor($value_temp / $krok);
           $left_val = $min_val * $krok;
           $right_val = ($min_val+1) * $krok;
           $center = floor((($left_val+$right_val) / 2) + 1);
           
           if ($value_temp < $center){
                $rest = ($left_val / 100);
           } else {
               $rest = ($right_val / 100);
           }
           
         return floor($value) + $rest;

       } else {
           
           $krok = $prmtr;
           
           $value = round($value, 2);
           $value_temp = round(100*($value - floor($value)));
           $value = floor($value);
           
           $min_val = floor($value / $krok);
           $left_val = $min_val * $krok;
           $right_val = ($min_val+1) * $krok;
           $center = floor(($left_val+$right_val) / 2);
           
           if ($value < $center){
               $result = $left_val;
           } else {
               $result = $right_val;
           }
         
         return $result;
           
       }
 	}
 	
 	public function onListProductUpdateData(&$products){
 		foreach($products as $k=>$v){
 			$products[$k]->product_price = $this->roundToParameterPrice($products[$k]->product_price);
 			$products[$k]->product_old_price = $this->roundToParameterPrice($products[$k]->product_old_price);
 			$products[$k]->_original_product_price = (string)$this->roundToParameterPrice((float)$products[$k]->_original_product_price);
 			$products[$k]->product_price_wp = $this->roundToParameterPrice($products[$k]->product_price_wp);
 			if(count($products[$k]->basic_price_info))$products[$k]->basic_price_info["basic_price"] = $this->roundToParameterPrice($products[$k]->basic_price_info["basic_price"]);
 		}	
 	}
 	
 	public function onCalculatePriceProduct($quantity, $enableCurrency, $enableUserDiscount, $enableParamsTax, &$product, &$cartProduct){
 		$product->product_old_price = (string)$this->roundToParameterPrice((float)$product->product_old_price);
 		$product->product_buy_price = (string)$this->roundToParameterPrice((float)$product->product_buy_price);
 		$product->product_price = (string)$this->roundToParameterPrice((float)$product->product_price);
 		$product->product_price_wp = $this->roundToParameterPrice($product->product_price_wp);
 		$product->product_price_calculate = $this->roundToParameterPrice($product->product_price_calculate);
 		$product->product_price_calculate1 = $this->roundToParameterPrice($product->product_price_calculate1); 		
 	}

 	public function updateOtherPricesIncludeAllFactors(&$product){
 		if (count($product->product_add_prices)){
 			foreach($product->product_add_prices as $k=>$v){
 				$product->product_add_prices[$k]->price = $this->roundToParameterPrice($product->product_add_prices[$k]->price);
 				$product->product_add_prices[$k]->price_wp = $this->roundToParameterPrice($product->product_add_prices[$k]->price_wp);
 			}
 		}
 	}

}